package api

type ResponseMessage struct {
	Status            string   `json:"status"`
	MultisigAddress   string   `json:"multisig_address"`
	MultisigInfo      string   `json:"multisig_info"`
	MultisigInfoPeers []string `json:"multisig_info_peers"`
}

type Response struct {
	Message ResponseMessage `json:"message"`
}

func (r Response) IsCreated() bool {
	return r.Message.Status == "created"
}

func (r Response) IsPrepared() bool {
	return r.Message.Status == "prepared"
}

func (r Response) IsMade() bool {
	return r.Message.Status == "made"
}

func (r Response) IsFinalized() bool {
	return r.Message.Status == "finalized"
}
