package main

import (
	"github.com/urfave/cli/v2"
)

func (a *Application) commands() {
	a.app = &cli.App{
		Name:            "mmc",
		Version:         Version,
		Usage:           "Monero Multisig client (proof-of-concept)",
		HideHelpCommand: true,
		Commands: cli.Commands{
			&cli.Command{
				Name:            "prepare",
				Usage:           "Prepare a multisig wallet",
				ArgsUsage:       "<secret>",
				Before:          a.prepare(),
				Action:          a.handlePrepareWallet(),
				HideHelpCommand: true,
				Flags: []cli.Flag{
					&cli.StringFlag{
						Name:  "secret",
						Required: true,
						Usage: "set secret string",
					},
					&cli.StringFlag{
						Name:  "wallet-language",
						Value: "English",
						Usage: "set wallet language",
					},
				},
			},
			&cli.Command{
				Name:            "transfer",
				Usage:           "Issue a transfer from the multisig wallet",
				ArgsUsage:       "<amount> <address>",
				Before:          a.prepare(),
				Action:          a.handleTransfer(),
				HideHelpCommand: true,
				Flags: []cli.Flag{
					&cli.StringFlag{
						Name:  "secret",
						Required: true,
						Usage: "set secret string",
					},
					&cli.StringFlag{
						Name:  "wallet-language",
						Value: "English",
						Usage: "set wallet language",
					},
				},
			},
		},
		Flags: []cli.Flag{
			&cli.StringFlag{
				Name:  "wallet-rpc",
				Value: "http://localhost:18082/json_rpc",
				Usage: "Monero Wallet RPC URI",
			},
		},
	}
}
